 

function [settings, images]= patch_struct(images, settings)   
               
%% Patch number and image size
        patch_nbr = 0; 
        patch_positions = []; 
        images_tmp =[]; 
        patch_overlap = settings.patch_overlap; 
        patch_size = settings.patch_size; 
        image_size = size(images(:,:,1));
        
        Lx = image_size(2)- patch_overlap;
        Ly = image_size(1)- patch_overlap;
        R  = patch_size - patch_overlap;
        
        xPad = patch_size - rem(Lx,R) - patch_overlap;  
        yPad = patch_size - rem(Ly,R) - patch_overlap;  
        
        for i =1:size(images,3)                                            % Resize image            
        images_tmp(:,:,i) = padarray(images(:,:,i),[yPad xPad],'post');  
        end 

        images = images_tmp;    
        images(isnan(images)) = 0;

        yPad2 = size(images,1) - image_size(1); 
        xPad2 = size(images,2) - image_size(2); 
        settings.xpad = xPad2; 
        settings.ypad = yPad2; 
        
        patch_col = round(Lx/R + 0.5);                                     % Number of patches/column
        patch_row = round(Ly/R + 0.5);                                     % Number of patches/row
        
%% Patch positions and indexes
        k = 1; 
        patch_index = [];
        settings.T = 0.0039*(settings.patch_size^2);
        for i=1:patch_row
            for j=1:patch_col      
                Start_i = 1+ (i-1)*(patch_size- patch_overlap);            % Patch starting/ending index
                End_i   = Start_i + patch_size - 1; 
                Start_j = 1+ (j-1)*(patch_size- patch_overlap); 
                End_j   = Start_j + patch_size - 1; 
                
                patch_tmpi = (Start_i:End_i)';                             % Patch position update            
                patch_tmpj = (Start_j:End_j)'; 
                patch_positions(:,:,(patch_nbr+1)) = [patch_tmpi,patch_tmpj];
                
                patch_nbr = patch_nbr+1;                                   % patch number
                
                if sum(sum(abs(images(patch_tmpi,patch_tmpj,k))>0)) > settings.T; % Discard all-zero patches 
                   patch_index = [patch_index  patch_nbr]; 
                end                   
            end
        end
        settings.patch_index = patch_index;  
            
patch_nbr = length(settings.patch_index); 
settings.positions = patch_positions; 
settings.patch_nbr = patch_nbr; 
settings.indexes = patch_index; 
settings.image_size = size(images); 
settings.image_size0 = image_size;
end