
I = u_bench_all; 

% extract 8 x 8 patches
X=im2col(I,[32 32],'sliding');
X=X-repmat(mean(X),[size(X,1) 1]);
X=X ./ repmat(sqrt(sum(X.^2)),[size(X,1) 1]);

X = X(:,~all(isnan(X)));

param.K=(32^2)*1.5;   % learns a dictionary with 100 elements
param.lambda=5;
param.numThreads=-1; % number of threads
param.verbose=false;
param.mode= 3; 

param.iter=600;  % let us see what happens after 1000 iterations.
tic
D = mexTrainDL(X,param);
t=toc;
fprintf('time of computation for Dictionary Learning: %f\n',t);


ImD=displayPatches(D);
imagesc(ImD); colormap('gray');
drawnow;